//Author: Max Krasnow
//Collaborators: Andy Delton, John Tooby, Leda Cosmides
//Compiled: August 8, 2011

/*
Copyright  2011.  The Regents of the University of California (Regents).
All rights reserved.
Redistribution and use in source and binary forms, with or without modification, are permitted for non-commercial educational, non-commercial research, and not-for-profit purposes only, provided that the following conditions are met:
	Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
	Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
	Neither the name of The Regents or the University of California nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package sim1;

import java.util.ArrayList;

public class BFagent extends agent{
    //instance variables
    int intention;
    double stamp;
    ArrayList<Integer> memory;
    
    //Creates a new instance of BFagent
    public BFagent(double bc, double mrate, double msize){
        genes = new ArrayList();
        fitness = 0;
        paramGene theGene = new paramGene(bc);
        theGene.mutation(mrate,msize);
        genes.add(theGene);
        stamp = Math.pow((-2*Math.log(Math.random())),.5) * Math.cos(2*Math.PI*Math.random());
        memory = new ArrayList();
    }
    
    public double getStamp(){
        return stamp;
    }
    public void setStamp(double s){
        stamp = s;
    }
    public double getBC(){
        return (Double) genes.get(0).value;
    }
    
    public char BFcog(double otherStamp, double errorRate){
        double rnd = Math.random();
        if(!memory.isEmpty()){
            if(memory.get(0)==1){
                if(rnd<errorRate){
                    return 'd';
                } else {
                    return 'c';
                }
            } else if(memory.get(0)==0){
                return 'd';
            }
        } else {
            if(otherStamp<(Double) genes.get(0).value){
                intention = 1;
                if(rnd<errorRate){
                    return 'd';
                } else {
                    return 'c';
                }
            } else {
                intention=0;
                return 'd';
            }
        }
        return 'n';
    }
    
    public void BFexperience(char exp){
        if(memory.isEmpty() && intention==1){
            if(exp=='c'){
                memory.add(1);
            } else {
                memory.add(0);
            }
        } else if(memory.isEmpty() && intention==0) {
            memory.add(0);
        } else {
            if(exp=='d'){
                memory.set(0,0);
            }
        }
    }
}
