//Author: Max Krasnow
//Collaborators: Andy Delton, John Tooby, Leda Cosmides
//Compiled: August 8, 2011

/*
Copyright  2011.  The Regents of the University of California (Regents).
All rights reserved.
Redistribution and use in source and binary forms, with or without modification, are permitted for non-commercial educational, non-commercial research, and not-for-profit purposes only, provided that the following conditions are met:
	Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
	Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
	Neither the name of The Regents or the University of California nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package sim1;

import java.util.ArrayList;

public class BIagent extends agent {
    //instance variables
    int intention;
    double stamp, d;
    ArrayList<Integer> memory;
    
    //Creates a new instance of BIagent
    public BIagent(double a, double b, double mrate, double msize){
        genes = new ArrayList();
        fitness = 0;
        probGene PrCifR = new probGene(a);
        probGene PrCifOS = new probGene(b);
        PrCifR.mutation(mrate, msize);
        PrCifOS.mutation(mrate, msize);
        genes.add(PrCifR);
        genes.add(PrCifOS);
        stamp = Math.pow((-2*Math.log(Math.random())),.5) * Math.cos(2*Math.PI*Math.random());
        memory = new ArrayList();
    }
    public void setStamp(double s){
        stamp = s;
    }
    public double getStamp(){
        return stamp;
    }
    public double[] getprCifRprCifOS(){
        double[] toReturn= {genes.get(0).value,genes.get(1).value};
        return toReturn;
    }
    
    private char thinksR(double errorRate){
        double rand = Math.random();
        double rand2 = Math.random();
        if(rand<genes.get(0).value){
            intention=1;
            if(rand2>errorRate){
                return 'c';
            } else {
                return 'd';
            }
        } else {
            intention=0;
            return 'd';
        }
    }
    private char thinksOS(double errorRate){
        double rand = Math.random();
        double rand2 = Math.random();
        if(rand<genes.get(1).value){
            intention=1;
            if(rand2>errorRate){
                return 'c';
            } else {
                return 'd';
            }
        } else {
            intention=0;
            return 'd';
        }
    }
    public char BIcog(double stamp, double osp, double d, double errorRate){
        char decision;
        double rand = Math.random();
        if(!memory.isEmpty()){
            if(memory.get(0)==1){
                if(rand<errorRate){
                    return 'd';
                } else {
                    return 'c';
                }
            } else if(memory.get(0)==0){
                return 'd';
            }
        } else {
                if(((osp)*(1/Math.pow((2*Math.PI),0.5))*(Math.exp((-1)*Math.pow((stamp-d/2),2)/2)))>(1-osp)*(1/Math.pow((2*Math.PI),0.5))*(Math.exp((-1)*Math.pow((stamp+d/2),2)/2))){
                    decision = thinksOS(errorRate);
                } else {
                    decision = thinksR(errorRate);
                }
                return decision;
            }
        return 'n';
    }
    
    public void BIexperience(char exp){
        if(memory.isEmpty() && intention==1){
            if(exp=='c'){
                memory.add(1);
            } else {
                memory.add(0);
            }
        } else if(memory.isEmpty() && intention==0) {
            memory.add(0);
        } else {
            if(exp=='d'){
                memory.set(0,0);
            }
        }
    }
}
