//Main.java
//Author: Max Krasnow
//Collaborators: Andy Delton, John Tooby, Leda Cosmides 
//Compiled: August 8, 2011

/*
Copyright  2011.  The Regents of the University of California (Regents).
All rights reserved.
Redistribution and use in source and binary forms, with or without modification, are permitted for non-commercial educational, non-commercial research, and not-for-profit purposes only, provided that the following conditions are met:
	Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
	Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
	Neither the name of The Regents or the University of California nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package sim1;

import java.awt.*;
import java.io.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;


public class Main {
    
    JFrame theFrame;
    JTextField benefitField, costField, popsizeField, genField, basefitField, mutationrateField, mutationsizeField, ospercentField, wField, dField, directoryField, iterationsField, errorField;
    JCheckBox save;
    JComboBox games;
    double optimum;
    String message;
    ArrayList<result> results;
    ArrayList<paramsList> runsList;
    JPanel topPanel, parameters, panel1, panel2, panel3, panel4, panel5, panel6, directoryPanel, detailsPanel, logoPanel, southPanel;
    JTextPane description;
    graphPanel drawPanel;
    environment theEnvironment;
    char action = 'R';
    Rectangle r = new Rectangle(800,400);
    
    public static void main(String[] args) {
        Main sim = new Main();
        sim.buildGUI();
        
    }
    
    public void buildGUI(){
       theFrame = new JFrame("AdaptSim! Produced by the UCSB Center for Evolutionary Psychology");
       theFrame.setResizable(false);
       theFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);   
             
       
       String[] gamesList = {"", "Cognition Evolves", "Motivation Evolves"};
       games = new JComboBox(gamesList);
       games.setEditable(false);
       games.addActionListener(new gamesListener());
       JLabel gamesLabel = new JLabel("Choose Game to Play");
   
       JLabel logo = new JLabel();
       ImageIcon logoicon = new ImageIcon("CEPlogo.jpg");
       logo.setIcon(logoicon);
       
       logoPanel = new JPanel();
       logoPanel.add(logo);
       JButton startSim = new JButton("G0!");
       startSim.addActionListener(new StartButtonListener());
       results = new ArrayList();
       JPanel simControl = new JPanel();
       simControl.setLayout(new BoxLayout(simControl,BoxLayout.Y_AXIS));
       simControl.add(gamesLabel);
       simControl.add(games);
       simControl.add(startSim);
          
       description = new JTextPane();
       description.setEditable(false);
       description.setText("");

       topPanel = new JPanel();
       topPanel.setLayout(new BoxLayout(topPanel,BoxLayout.X_AXIS));
       topPanel.add(simControl);
       topPanel.add(description);
       detailsPanel = new JPanel();
       //detailsPanel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
       Dimension detailsSize = new Dimension(800,175);
       detailsPanel.setPreferredSize(detailsSize);
       detailsPanel.setBackground(Color.LIGHT_GRAY);
       detailsPanel.add(logoPanel);
       drawPanel = new graphPanel();
       topPanel.setPreferredSize(new Dimension(800,75));
       southPanel = new JPanel();
       southPanel.setLayout(new BoxLayout(southPanel, BoxLayout.Y_AXIS));
       southPanel.setPreferredSize(new Dimension(800,400));
       southPanel.add(drawPanel);
       theFrame.setLayout(new BorderLayout());
       theFrame.getContentPane().add(BorderLayout.NORTH, topPanel);
       theFrame.getContentPane().add(BorderLayout.CENTER, detailsPanel);
       theFrame.getContentPane().add(BorderLayout.SOUTH, southPanel);
       
       theFrame.setBounds(50,50,800,650);
       theFrame.setPreferredSize(new Dimension(800,750));
       theFrame.setVisible(true);
       theFrame.validate();
   }

    
    class graphPanel extends JPanel implements resultListener{

        int iterator, length, height, newx, newy, lastPoint, refy; 
        int counter=0;
        boolean cue = false;
        result thisResult;
        String text, text2, text3;
        Dimension size = new Dimension(800,400);    
        
        @Override
        public void paintComponent(Graphics g){
            switch (action){
                case 'R': //PreGraph - just displays the intro screen
                    newx=10;
                    text = "This is AdaptSim, the Center for Evolutionary Psychology's program for Adaptive Game Theory modeling.";
                    text2 = "If you specificy a directory, the simulation data will be saved as a series of files for you.";
                    text3 = "The simulation data from the latest run will be graphed for you here (until you change simulations or new data comes in).";
                    g.setColor(Color.WHITE);
                    g.drawLine(0,0,800,0);
                    g.setColor(Color.BLACK);         
                    g.fillRect(0,1,800,400);
                    g.setColor(Color.WHITE);
                    g.drawString(text, 20, 20);
                    g.drawString(text2, 20, 60);
                    g.drawString(text3, 20, 75);
                    break;
                case 'S':  //Setup Graph - doesn't graph any data, just sets up the axis and variables
                    newx=10;
                    counter = 1;
                    g.setColor(Color.BLACK);         
                    g.fillRect(0,1,800,400);
                    text = "Results: ";
                    g.setColor(Color.WHITE);
                    g.drawString(text, 20, 20);
                    iterator = (int)Math.ceil(Double.parseDouble(genField.getText())/(double)600);
                    length = (int)Math.floor(Double.parseDouble(genField.getText())/(double)iterator);
                    height = 300;
                    if(games.getSelectedItem()=="Cognition Evolves"){
                        g.drawLine(10, (int)Math.round(height/2)+50, length+10, (int)Math.round(height/2)+50);
                    } else {
                        g.drawLine(10, height+50, length+10, height+50);
                    }
                    g.drawLine(10,50,10,height+50);
                    g.drawLine(10,275,15,275);
                    g.drawLine(10,200,15,200);
                    g.drawLine(10,125,15,125);
                    for(int x=0; x<=length; x+=100){
                        String temp = Integer.toString(x*iterator);
                        g.drawString(temp, x+10, height+70);

                    }
                    break;
                case 'G':  //Live graphing option - graphs each datapoint that comes in from result listener
                    g.setColor(Color.BLACK);
                    g.fillRect(0, 0, 100, 10);
                    g.setColor(Color.WHITE);
                    g.drawString(Long.toString(Math.round(thisResult.gen)), 5, 10);
                    for(TypeDistribution thisDist:thisResult.typesDist){
                        if(thisDist.type.matches("BC")){g.setColor(Color.RED);}
                        if(thisDist.type.matches("prCifR")){g.setColor(Color.BLUE);}
                        if(thisDist.type.matches("prCifOS")){g.setColor(Color.RED);}
                        if(thisDist.type.matches("BC")){
                            newy=50+(int)Math.round(height/2) - (int)Math.round(thisDist.proportion*height);
                        } else {
                            newy=50+height-(int)Math.round(thisDist.proportion*height);
                        }
                        g.drawLine(newx,newy,newx,newy);
                    }
                    newx++;
                    action = 'O';
                    break;
                case 'O':  // Static graphing option - graphs full dataset (for re-draws, etc)
                    g.setColor(Color.BLACK);
                    g.fillRect(0,1,800,400);
                    text = "Results: ";
                    g.setColor(Color.WHITE);
                    g.drawString(text, 20, 20);
                    iterator = (int)Math.ceil(Double.parseDouble(genField.getText())/(double)600);
                    length = (int)Math.floor(Double.parseDouble(genField.getText())/(double)iterator);
                    height = 300;
                    if(games.getSelectedItem()=="Cognition Evolves"){
                        g.drawLine(10, (int)Math.round(height/2)+50, length+10, (int)Math.round(height/2)+50);
                        g.drawString("Rising values indicate agents biased to believe inxns are repeated", 20, 40);
                    } else {
                        g.drawLine(10, height+50, length+10, height+50);
                        g.drawString("Prob. Coop. Believe OS = Red; Prob. Coop. Believe R = Blue; Prob. range = 0-1 (low-high)", 20, 40);
                    }
                    g.drawLine(10,50,10,height+50);
                    g.drawLine(10,275,15,275);
                    g.drawLine(10,200,15,200);
                    g.drawLine(10,125,15,125);
                    for(int x=0; x<=length; x+=100){
                        String temp = Integer.toString(x*iterator);
                        g.drawString(temp, x+10, height+70);

                    }
                    newx=10;
                    for(int x=0; x<results.size(); x+=iterator){
                        thisResult = results.get(x);
                        for(TypeDistribution thisDist:thisResult.typesDist){
                            if(thisDist.type.matches("BC")){g.setColor(Color.RED);}
                            if(thisDist.type.matches("prCifR")){g.setColor(Color.BLUE);}
                            if(thisDist.type.matches("prCifOS")){g.setColor(Color.RED);}
                            if(thisDist.type.matches("BC")){
                                newy=50+(int)Math.round(height/2) - (int)Math.round(thisDist.proportion*height);
                            } else {
                                newy=50+height-(int)Math.round(thisDist.proportion*height);
                            }
                            g.drawLine(newx,newy,newx,newy);
                        }
                        newx++;
                    }
                    break;
                //end of switch
            }
        }

        @Override
        public void resultReceived(resultEvent event) {     
            thisResult = event.getResult();
            if(thisResult.gen==1){
                action='O';
                this.paintImmediately(r);
            }
            if(counter == iterator){
                action = 'G';
                counter=1;
                this.paintImmediately(r);
            } else {
                counter++;
            }
        }
    }
                        
    class DirectorySelectListener implements ActionListener {
        @Override
        public void actionPerformed(ActionEvent event){
            JFileChooser directory = new JFileChooser();
            directory.setFileSelectionMode(2);
            directory.setDialogTitle("Select the directory to save results");
            directory.showSaveDialog(theFrame);
            directoryField.setText(directory.getSelectedFile().getPath());
            theFrame.repaint();
        }
    }
    
    class gamesListener implements ActionListener {
        @Override
        public void actionPerformed(ActionEvent event) {
            action = 'R';
            drawPanel.repaint();
            detailsPanel.removeAll();
            detailsPanel.setLayout(new BoxLayout(detailsPanel,BoxLayout.Y_AXIS));
            detailsPanel.setBackground(Color.LIGHT_GRAY);
            directoryPanel = new JPanel();
            directoryPanel.setLayout(new BoxLayout(directoryPanel,BoxLayout.X_AXIS));
            directoryPanel.setBackground(Color.LIGHT_GRAY);
            parameters = new JPanel();
            parameters.setBackground(Color.LIGHT_GRAY);
            panel1 = new JPanel();
            panel1.setBackground(Color.DARK_GRAY);
            panel1.setLayout(new BoxLayout(panel1,BoxLayout.Y_AXIS));
            panel2 = new JPanel();
            panel2.setBackground(Color.DARK_GRAY);
            panel2.setLayout(new BoxLayout(panel2,BoxLayout.Y_AXIS));
            panel3 = new JPanel();
            panel3.setBackground(Color.DARK_GRAY);
            panel3.setLayout(new BoxLayout(panel3,BoxLayout.Y_AXIS));
            panel4 = new JPanel();
            panel4.setBackground(Color.DARK_GRAY);
            panel4.setLayout(new BoxLayout(panel4,BoxLayout.Y_AXIS));
            panel5 = new JPanel();
            panel5.setBackground(Color.DARK_GRAY);
            panel5.setLayout(new BoxLayout(panel5,BoxLayout.Y_AXIS));
            panel6 = new JPanel();
            panel6.setBackground(Color.DARK_GRAY);
            panel6.setLayout(new BoxLayout(panel6,BoxLayout.Y_AXIS));
            benefitField = new JTextField(5);
            costField = new JTextField(5);
            popsizeField = new JTextField(5);
            genField = new JTextField(5);
            basefitField = new JTextField(5);
            mutationrateField = new JTextField(5);
            mutationsizeField = new JTextField(5);
            ospercentField = new JTextField(5);
            wField = new JTextField(5);
            dField = new JTextField(5);
            errorField = new JTextField(5);
            directoryField = new JTextField(50);
            iterationsField = new JTextField(5);
            JLabel benefitLabel = new JLabel("Benefit");
            benefitLabel.setForeground(Color.WHITE);
            JLabel costLabel = new JLabel("Cost");
            costLabel.setForeground(Color.WHITE);
            JLabel popsizeLabel = new JLabel("Population Size");
            popsizeLabel.setForeground(Color.WHITE);
            JLabel basefitLabel = new JLabel("Baseline Fitness");
            basefitLabel.setForeground(Color.WHITE);
            JLabel genLabel = new JLabel("# Generations");
            genLabel.setForeground(Color.WHITE);
            JLabel mutationsizeLabel = new JLabel("Mutation Size (sd)");
            mutationsizeLabel.setForeground(Color.WHITE);
            JLabel mutationrateLabel = new JLabel("Mutation Rate");
            mutationrateLabel.setForeground(Color.WHITE);
            JLabel ospercentLabel = new JLabel("Proportion One Shot");
            ospercentLabel.setForeground(Color.WHITE);
            JLabel iterationsLabel = new JLabel("# Runs / Combo");
            iterationsLabel.setForeground(Color.WHITE);
            JLabel wLabel = new JLabel("w (lifetime)");
            wLabel.setForeground(Color.WHITE);
            JLabel dLabel = new JLabel("d (discriminability)");
            dLabel.setForeground(Color.WHITE);
            JLabel directoryLabel = new JLabel("Save Directory:");
            directoryLabel.setForeground(Color.WHITE);
            JLabel errorLabel = new JLabel("Error Rate");
            errorLabel.setForeground(Color.WHITE);
            JButton directoryButton = new JButton("Browse For Directory");
            directoryButton.addActionListener(new DirectorySelectListener());
            directoryPanel.add(directoryLabel);
            directoryPanel.add(directoryField);
            directoryPanel.add(directoryButton);
            String bf="In a 'Cognition Evolves' game, agents are randomly paired. A proportion of them plays a one-shot prisoner's dilemma (PD), while the rest play a repeated PD. Each agent is assigned a cue value probabalistically assoicated with their group type, and they use a genetic decision threshold and this cue to decide how to make their first decision. After that, all agents play GRIM (cooperate until defected on).";
            String bi="In a 'Motivation Evolves' game, agents are randomly paired. A proportion of them plays a one-shot prisoner's dilemma (PD), while the rest play a repeated PD. Each agent is assigned a cue value probabalistically assoicated with their group type, and they use Bayes' Theorem to pick the likeliest state of the group given their partner's cue. They then access a gene for that likely group type, and cooperate with that probability.";

            JComboBox games = (JComboBox)event.getSource();
            if(games.getSelectedItem()=="Cognition Evolves"){
                benefitField.setText("5");
                costField.setText("1");
                basefitField.setText("10");
                popsizeField.setText("500");
                genField.setText("10000");
                iterationsField.setText("1");
                mutationsizeField.setText(".025");
                mutationrateField.setText(".05");
                errorField.setText(".00");
                ospercentField.setText(".5");
                wField.setText(".9");
                dField.setText("2");
                panel1.add(benefitLabel);
                panel1.add(benefitField);
                panel1.add(costLabel);
                panel1.add(costField);
                panel1.add(basefitLabel);
                panel1.add(basefitField);
                panel2.add(popsizeLabel);
                panel2.add(popsizeField);
                panel2.add(genLabel);
                panel2.add(genField);
                panel2.add(iterationsLabel);
                panel2.add(iterationsField);
                panel3.add(mutationsizeLabel);
                panel3.add(mutationsizeField);
                panel3.add(mutationrateLabel);
                panel3.add(mutationrateField);
                panel3.add(errorLabel);
                panel3.add(errorField);
                panel4.add(ospercentLabel);
                panel4.add(ospercentField);
                panel4.add(wLabel);
                panel4.add(wField);
                panel4.add(dLabel);
                panel4.add(dField);
                description.setText(bf);
                parameters.add(panel1);
                parameters.add(panel2);
                parameters.add(panel3);
                parameters.add(panel4);
                detailsPanel.add(parameters);
                detailsPanel.add(directoryPanel);
                theFrame.validate();
                
            }
            if(games.getSelectedItem()=="Motivation Evolves"){
                benefitField.setText("5");
                costField.setText("1");
                basefitField.setText("10");
                popsizeField.setText("500");
                genField.setText("10000");
                iterationsField.setText("1");
                mutationsizeField.setText(".025");
                mutationrateField.setText(".05");
                errorField.setText(".00");
                ospercentField.setText(".5");
                wField.setText(".9");
                dField.setText("2");
                panel1.add(benefitLabel);
                panel1.add(benefitField);
                panel1.add(costLabel);
                panel1.add(costField);
                panel1.add(basefitLabel);
                panel1.add(basefitField);
                panel2.add(popsizeLabel);
                panel2.add(popsizeField);
                panel2.add(genLabel);
                panel2.add(genField);
                panel2.add(iterationsLabel);
                panel2.add(iterationsField);
                panel3.add(mutationsizeLabel);
                panel3.add(mutationsizeField);
                panel3.add(mutationrateLabel);
                panel3.add(mutationrateField);
                panel3.add(errorLabel);
                panel3.add(errorField);
                panel4.add(ospercentLabel);
                panel4.add(ospercentField);
                panel4.add(wLabel);
                panel4.add(wField);
                panel4.add(dLabel);
                panel4.add(dField);
                description.setText(bi);
                parameters.add(panel1);
                parameters.add(panel2);
                parameters.add(panel3);
                parameters.add(panel4);
                detailsPanel.add(parameters);
                detailsPanel.add(directoryPanel);
                theFrame.validate();
                
            }
            if(games.getSelectedItem()==""){
                description.setText("");
                detailsPanel.add(logoPanel);
                theFrame.validate(); 
            }
        }
    }
       
    class StartButtonListener implements ActionListener {
        @Override
        public void actionPerformed(ActionEvent event) {
            ArrayList<JTextField> fields = new ArrayList();
            ArrayList<JTextField> nullfields = new ArrayList();
            if(games.getSelectedItem()=="Cognition Evolves"){
                fields.add(benefitField);
                fields.add(costField);
                fields.add(basefitField);
                fields.add(popsizeField);
                fields.add(genField);
                fields.add(mutationsizeField);
                fields.add(mutationrateField);
                fields.add(ospercentField);
                fields.add(dField);
                fields.add(wField);
                fields.add(iterationsField);
                fields.add(errorField);
                if(validateParams(fields, nullfields)){
                    setUpRun();
                    if(!directoryField.getText().isEmpty()){
                        String tempdirectory = directoryField.getText() +"\\temp";
                        File tempdir = new File(tempdirectory);
                        tempdir.mkdir();
                        tempdir.deleteOnExit();
                    }
                    for(int x=0; x<runsList.size(); x++){
                        optimum = OptimumX(runsList.get(x).osp,runsList.get(x).d);
                        ArrayList<TypeDistribution> typesDist = new ArrayList();
                        TypeDistribution startBC = new TypeDistribution("BC", optimum);
                        typesDist.add(startBC);
                        //b,c,basefit,popsize,gen,ms,mr,osp,d,w,i
                        runsList.get(x).basefit=Double.parseDouble(basefitField.getText());
                        runsList.get(x).ms=Double.parseDouble(mutationsizeField.getText());
                        runsList.get(x).mr=Double.parseDouble(mutationrateField.getText());
                        runsList.get(x).optimum=optimum;
                        runsList.get(x).popsize=Integer.parseInt(popsizeField.getText());
                        runsList.get(x).gens=Integer.parseInt(genField.getText());
                        runsList.get(x).game=(String)games.getSelectedItem();
                        runsList.get(x).typesDist=typesDist;
                        runsList.get(x).errorRate=Double.parseDouble(errorField.getText());
                        paramsList thisParam = runsList.get(x);
                        population thePopulation = new population(thisParam.popsize, thisParam.typesDist.get(0).proportion, thisParam.ms);
                        theEnvironment = new environment(thePopulation);
                        theEnvironment.addResultListener(drawPanel);
                        int thisgen = 1;
                        results = new ArrayList();
                        while (thisgen<=thisParam.gens){
                            theEnvironment.thePopulation.shuffle();
                            theEnvironment.thePopulation.formGroups(2);
                            result thisResult = theEnvironment.thePopulation.beliefFormation(thisParam.b, thisParam.c, thisParam.w, thisParam.basefit, thisParam.d, thisParam.osp, thisParam.mr, thisParam.ms, thisParam.errorRate);
                            thisResult.gen=thisgen;
                            thisResult.resultType = "Cognition Evolves";
                            theEnvironment.thePopulation = new population(thisResult.AgentList);
                            theEnvironment.fireResultEvent(thisResult);
                            results.add(thisResult);
                            thisgen++;
                        }

                        if(!directoryField.getText().isEmpty()){
                            String filename = directoryField.getText() + "\\" + "b" + runsList.get(x).b + "c" + runsList.get(x).c + "w" + runsList.get(x).w + "d" + runsList.get(x).d +"osp" + runsList.get(x).osp + "i" + runsList.get(x).i + "results.csv";
                            File thisfile = new File(filename);
                            saveFile(thisfile, "Cognition Evolves");
                            String tempfilename = directoryField.getText() + "\\temp\\" + x + ".ser";
                            File tempfile = new File(tempfilename);
                            try {
                                tempfile.createNewFile();
                                tempfile.deleteOnExit();
                            } catch (IOException ex) {
                                ex.printStackTrace();
                            }
                            SerializeRun(results, tempfile);
                        }
                    }
                    if(!directoryField.getText().isEmpty()){
                        String filename = directoryField.getText() + "\\" + (String)games.getSelectedItem() + "," +"b" + (String)benefitField.getText() + "c" + (String)costField.getText() + "w" + (String)wField.getText() + "osp" + (String)ospercentField.getText() + "d" + (String)dField.getText() + "base" + (String)basefitField.getText() + "popsize" + (String)popsizeField.getText() + "gens" + (String)genField.getText() + "ms" + (String)mutationsizeField.getText() + "mr" + (String)mutationrateField.getText() + "i" + (String)iterationsField.getText() + "results.csv";
                        File thisfile = new File(filename);
                        AllAgentsFile(thisfile, "Cognition Evolves");
                    }
                }
            }
            if(games.getSelectedItem()=="Motivation Evolves"){
                fields.add(benefitField);
                fields.add(costField);
                fields.add(basefitField);
                fields.add(popsizeField);
                fields.add(genField);
                fields.add(mutationsizeField);
                fields.add(mutationrateField);
                fields.add(ospercentField);
                fields.add(dField);
                fields.add(wField);
                fields.add(iterationsField);
                fields.add(errorField);
                if(validateParams(fields, nullfields)){
                    setUpRun();
                    ArrayList<TypeDistribution> typesDist = new ArrayList();
                    TypeDistribution startAlpha = new TypeDistribution("Alpha", 1);
                    TypeDistribution startBeta = new TypeDistribution("Beta", 0);
                    typesDist.add(startAlpha);
                    typesDist.add(startBeta);
                    if(!directoryField.getText().isEmpty()){
                        String tempdirectory = directoryField.getText() +"\\temp";
                        File tempdir = new File(tempdirectory);
                        tempdir.mkdir();
                        tempdir.deleteOnExit();
                    }
                    for(int x=0; x<runsList.size(); x++){
                        runsList.get(x).basefit=Double.parseDouble(basefitField.getText());
                        runsList.get(x).ms=Double.parseDouble(mutationsizeField.getText());
                        runsList.get(x).mr=Double.parseDouble(mutationrateField.getText());
                        runsList.get(x).popsize=Integer.parseInt(popsizeField.getText());
                        runsList.get(x).gens=Integer.parseInt(genField.getText());
                        runsList.get(x).game=(String)games.getSelectedItem();
                        runsList.get(x).typesDist=typesDist;
                        runsList.get(x).errorRate=Double.parseDouble(errorField.getText());
                        paramsList thisParam = runsList.get(x);
                        population thePopulation = new population(thisParam.popsize, thisParam.typesDist.get(0).proportion, thisParam.typesDist.get(1).proportion, thisParam.ms);
                        theEnvironment = new environment(thePopulation);
                        theEnvironment.addResultListener(drawPanel);
                        int thisgen = 1;
                        results = new ArrayList();
                        while (thisgen<=thisParam.gens){
                            theEnvironment.thePopulation.shuffle();
                            theEnvironment.thePopulation.formGroups(2);
                            result thisResult = theEnvironment.thePopulation.beliefImplementation(thisParam.b, thisParam.c, thisParam.w, thisParam.basefit, thisParam.d, thisParam.osp, thisParam.mr, thisParam.ms, thisParam.errorRate);
                            thisResult.gen=thisgen;
                            thisResult.resultType = "Motivation Evolves";
                            theEnvironment.thePopulation = new population(thisResult.AgentList);
                            theEnvironment.fireResultEvent(thisResult);
                            results.add(thisResult);
                            thisgen++;
                        }
                        if(!directoryField.getText().isEmpty()){
                            String filename = directoryField.getText() + "\\" + "b" + runsList.get(x).b + "c" + runsList.get(x).c + "w" + runsList.get(x).w + "d" + runsList.get(x).d +"osp" + runsList.get(x).osp + "i" + runsList.get(x).i + "results.csv";
                            File thisfile = new File(filename);
                            saveFile(thisfile, "Motivation Evolves");
                            String tempfilename = directoryField.getText() + "\\temp\\" + x + ".ser";
                            File tempfile = new File(tempfilename);
                            try {
                                tempfile.createNewFile();
                                tempfile.deleteOnExit();
                            } catch (IOException ex) {
                                ex.printStackTrace();
                            }
                            SerializeRun(results, tempfile);
                        }
                    }
                    if(!directoryField.getText().isEmpty()){
                        String filename = directoryField.getText() + "\\" + (String)games.getSelectedItem() + "," +"b" + (String)benefitField.getText() + "c" + (String)costField.getText() + "w" + (String)wField.getText() + "osp" + (String)ospercentField.getText() + "d" + (String)dField.getText() + "base" + (String)basefitField.getText() + "popsize" + (String)popsizeField.getText() + "gens" + (String)genField.getText() + "ms" + (String)mutationsizeField.getText() + "mr" + (String)mutationrateField.getText() + "i" + (String)iterationsField.getText() + "results.csv";
                        File thisfile = new File(filename);
                        AllAgentsFile(thisfile, "Motivation Evolves");
                    }
                }
            }
        } 
    }

     private void saveFile(File file, String game) {
        try {
            BufferedWriter writer = new BufferedWriter(new FileWriter(file));
            
            if(game.matches("Cognition Evolves")){
                for(result thisResult:results){
                    writer.write(thisResult.typesDist.get(0).type +  "," + thisResult.typesDist.get(0).proportion + "," + thisResult.typesDist.get(0).se + "," + optimum + "\n");
                }
            }
            if(game.matches("Motivation Evolves")){
                for(result thisResult:results){
                    writer.write(thisResult.typesDist.get(0).type + "," + thisResult.typesDist.get(0).proportion + "," + thisResult.typesDist.get(0).se + "," + thisResult.typesDist.get(1).type + "," + thisResult.typesDist.get(1).proportion + "," + thisResult.typesDist.get(1).se + "\n");
                }
            }
            results.clear();
            writer.close();
        } catch(IOException ex) {
            System.out.println("Couldn't write to file");
            ex.printStackTrace();
        }
        
    }
     
    private void SerializeRun(ArrayList<result> theseResults, File filename){
        try {
           FileOutputStream fos = new FileOutputStream(filename);
           ObjectOutputStream out = new ObjectOutputStream(fos);
           out.writeObject(theseResults);
           out.close(); 
        }
         catch(IOException ex) {
            ex.printStackTrace();
        }
     }
     
     private ArrayList<result> DeSerializeRun(String filename){
         ArrayList<result> thisResult = new ArrayList();
         try {
             FileInputStream fis = new FileInputStream(filename);
             ObjectInputStream in = new ObjectInputStream(fis);
             thisResult = (ArrayList<result>)in.readObject();
             in.close();
        } catch(IOException ex) {
            ex.printStackTrace();
        } catch(ClassNotFoundException ex) {
            ex.printStackTrace();
        }
         return thisResult;
     }
     
     private void AllAgentsFile(File file, String game){
         if(game.matches("Cognition Evolves")){
             try {
                 File summaryfile = new File(file.getAbsolutePath().replaceAll(".csv","")+"summary.csv");
                 BufferedWriter summarywriter = new BufferedWriter(new FileWriter(summaryfile));
                 summarywriter.write("B,C,BaseFit,W,D,OSP,MutSize,MutRate,PopSize,GenNumber,MeanBC,OptBC,BCsd,BCse,t,\n");
                 String directory = directoryField.getText();
                 directory+="\\temp\\";
                 File directoryFile = new File(directory);
                 String[] listofFiles = directoryFile.list();
                 for(int i=0; i<listofFiles.length; i++){
                     ArrayList<result> theseResults = DeSerializeRun(directory + listofFiles[i]);
                     double opt = theseResults.get(0).optimum;
                     for(result thisResult:theseResults){
                         summarywriter.write(thisResult.b + "," + thisResult.c + "," + thisResult.basefit + "," + thisResult.w + "," + thisResult.d + "," + thisResult.osp + "," + thisResult.ms + "," + thisResult.mr + "," + thisResult.pop + "," + thisResult.gen + "," + thisResult.typesDist.get(0).proportion + "," + opt + "," + thisResult.typesDist.get(0).sd + "," + thisResult.typesDist.get(0).se + "," + (thisResult.typesDist.get(0).proportion-opt)/thisResult.typesDist.get(0).se + ",");
                         summarywriter.write("\n");
                     }
                }
                summarywriter.close();
             } catch(IOException ex) {
                System.out.println("Couldn't write to file");
                ex.printStackTrace();
            }
        }
        if(game.matches("Motivation Evolves")){
             try {
                 File summaryfile = new File(file.getAbsolutePath().replaceAll(".csv","")+"summary.csv");
                 BufferedWriter summarywriter = new BufferedWriter(new FileWriter(summaryfile));
                 summarywriter.write("B,C,BaseFit,W,D,OSP,MutSize,MutRate,PopSize,GenNumber,PrCifR,Rsd,Rse,t,PrCifOS,OSsd,OSse,t,\n");
                 String directory = directoryField.getText();
                 directory+="\\temp\\";
                 File directoryFile = new File(directory);
                 String[] listofFiles = directoryFile.list();
                 for(int i=0; i<listofFiles.length; i++){
                     ArrayList<result> theseResults = DeSerializeRun(directory + listofFiles[i]);
                     for(result thisResult:theseResults){
                         summarywriter.write(thisResult.b + "," + thisResult.c + "," + thisResult.basefit + "," + thisResult.w + "," + thisResult.d + "," + thisResult.osp + "," + thisResult.ms + "," + thisResult.mr + "," + thisResult.pop + "," + thisResult.gen + "," + thisResult.typesDist.get(0).proportion + "," + thisResult.typesDist.get(0).sd + "," + thisResult.typesDist.get(0).se + "," + (1-0.028-thisResult.typesDist.get(0).proportion)/thisResult.typesDist.get(0).se + "," + thisResult.typesDist.get(1).proportion + "," + thisResult.typesDist.get(1).sd + "," + thisResult.typesDist.get(1).se + "," + (thisResult.typesDist.get(1).proportion-0.028)/thisResult.typesDist.get(1).se + ",");
                         summarywriter.write("\n");
                     }
                }
                summarywriter.close();
             } catch(IOException ex) {
                System.out.println("Couldn't write to file");
                ex.printStackTrace();
            }
        }
     }
   
     
     private double OptimumX(double osp, double d){
        optimum=0;
        double inc;
        if(osp > 0.5){
            inc = -.00001;
        } else if(osp < 0.5){
            inc = .00001;
        } else {
            return 0;
        }
        double difference=10;
        while(difference>0.000001){
            optimum+=inc;
            difference = Math.abs((osp)*(1/Math.pow((2*Math.PI),0.5))*(Math.exp((-1)*Math.pow((optimum-d/2),2)/2))-(1-osp)*(1/Math.pow((2*Math.PI),0.5))*(Math.exp((-1)*Math.pow((optimum+d/2),2)/2)));
        }
        return optimum;
    }
     private void setUpRun(){ //change to an ArrayList<paramsList>
         runsList = new ArrayList();
         if(games.getSelectedItem()=="Cognition Evolves" || games.getSelectedItem()=="Motivation Evolves"){
             String[] bens = benefitField.getText().split(",");
             String[] costs = costField.getText().split(",");
             String[] ws = wField.getText().split(",");
             String[] ds = dField.getText().split(",");
             String[] osps = ospercentField.getText().split(",");
             for(int x = 0; x < bens.length; x++){
                 for(int y = 0; y < costs.length; y++){
                     for(int z = 0; z < ws.length; z++){
                        for(int a = 0; a < ds.length; a++){
                             for(int b = 0; b < osps.length; b++){
                                 for(int c = 0; c < Math.floor(Double.parseDouble(iterationsField.getText())); c++){
                                     paramsList thisRun = new paramsList();
                                     thisRun.b=Double.parseDouble(bens[x]);
                                     thisRun.c=Double.parseDouble(costs[y]);
                                     thisRun.w=Double.parseDouble(ws[z]);
                                     thisRun.d=Double.parseDouble(ds[a]);
                                     thisRun.osp=Double.parseDouble(osps[b]);
                                     thisRun.i=c;
                                     runsList.add(thisRun);
                                 }
                             }
                         }
                     }
                 }
             }
         }
     }
     private boolean validateParams(ArrayList<JTextField> fields, ArrayList<JTextField> nullfields){
         int errors = 0;
         boolean validated = false;
         for(JTextField text:nullfields){
             text.setBackground(Color.WHITE);
         }
         for(JTextField text:fields){
             try {
                 String[] temp = text.getText().split(",");
                 for(String num:temp){
                     Double.parseDouble(num);
                 }
                 text.setBackground(Color.WHITE); 
             } catch(NumberFormatException ex) {
                 text.setBackground(Color.RED);
                 errors++;
             }
         }
         if(errors == 0){
             validated = true;
         }
         return validated;
     }
}